- [HTTP request](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs/recommend#body.aspect_1)

Makes a recommendation, which requires a contextual user event.

### HTTP request

Choose an endpoint:
global us   
`POST https://discoveryengine.googleapis.com/v1alpha/{servingConfig=projects/*/locations/*/collections/*/dataStores/*/servingConfigs/*}:recommend`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `servingConfig` | `string` Required. Full resource name of a `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.servingConfigs#ServingConfig`: `projects/*/locations/global/collections/*/engines/*/servingConfigs/*`, or `projects/*/locations/global/collections/*/dataStores/*/servingConfigs/*` One default serving config is created along with your recommendation engine creation. The engine ID is used as the ID of the default serving config. For example, for Engine `projects/*/locations/global/collections/*/engines/my-engine`, you can use `projects/*/locations/global/collections/*/engines/my-engine/servingConfigs/my-engine` for your `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.dataStores.servingConfigs/recommend#google.cloud.discoveryengine.v1alpha.RecommendationService.Recommend` requests. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "userEvent": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.dataStores.userEvents#UserEvent`) }, "pageSize": integer, "filter": string, "validateOnly": boolean, "params": { string: value, ... }, "userLabels": { string: string, ... } } ``` |

| Fields ||
|---|---|
| `userEvent` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.dataStores.userEvents#UserEvent`)`` Required. Context about the user, what they are looking at and what action they took to trigger the servingConfigs.recommend request. Note that this user event detail won't be ingested to userEvent logs. Thus, a separate userEvent write request is required for event logging. Don't set `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.dataStores.userEvents#UserEvent.FIELDS.user_pseudo_id` or `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/UserInfo#FIELDS.user_id` to the same fixed ID for different users. If you are trying to receive non-personalized recommendations (not recommended; this can negatively impact model performance), instead set `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.dataStores.userEvents#UserEvent.FIELDS.user_pseudo_id` to a random unique ID and leave `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/UserInfo#FIELDS.user_id` unset. |
| `pageSize` | `integer` Maximum number of results to return. Set this property to the number of recommendation results needed. If zero, the service chooses a reasonable default. The maximum allowed value is 100. Values above 100 are set to 100. |
| `filter` | `string` Filter for restricting recommendation results with a length limit of 5,000 characters. Currently, only filter expressions on the `filterTags` attribute is supported. Examples: - `(filterTags: ANY("Red", "Blue") OR filterTags: ANY("Hot", "Cold"))` - `(filterTags: ANY("Red", "Blue")) AND NOT (filterTags: ANY("Green"))` If `attributeFilteringSyntax` is set to true under the `params` field, then attribute-based expressions are expected instead of the above described tag-based syntax. Examples: - (language: ANY("en", "es")) AND NOT (categories: ANY("Movie")) - (available: true) AND (language: ANY("en", "es")) OR (categories: ANY("Movie")) If your filter blocks all results, the API returns generic (unfiltered) popular Documents. If you only want results strictly matching the filters, set `strictFiltering` to `true` in `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.dataStores.servingConfigs/recommend#body.request_body.FIELDS.params` to receive empty results instead. Note that the API never returns `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/projects.locations.collections.dataStores.branches.documents#Document`s with `storageStatus` as `EXPIRED` or `DELETED` regardless of filter choices. |
| `validateOnly` | `boolean` Use validate only mode for this recommendation query. If set to `true`, a fake model is used that returns arbitrary Document IDs. Note that the validate only mode should only be used for testing the API, or if the model is not ready. |
| `params` | ``map (key: string, value: value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format))`` Additional domain specific parameters for the recommendations. Allowed values: - `returnDocument`: Boolean. If set to `true`, the associated Document object is returned in `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/RecommendResponse#RecommendationResult.FIELDS.document`. - `returnScore`: Boolean. If set to true, the recommendation score corresponding to each returned Document is set in `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/RecommendResponse#RecommendationResult.FIELDS.metadata`. The given score indicates the probability of a Document conversion given the user's context and history. - `strictFiltering`: Boolean. True by default. If set to `false`, the service returns generic (unfiltered) popular Documents instead of empty if your filter blocks all recommendation results. - `diversityLevel`: String. Default empty. If set to be non-empty, then it needs to be one of: - `no-diversity` - `low-diversity` - `medium-diversity` - `high-diversity` - `auto-diversity` This gives request-level control and adjusts recommendation results based on Document category. - `attributeFilteringSyntax`: Boolean. False by default. If set to true, the `filter` field is interpreted according to the new, attribute-based syntax. |
| `userLabels` | `map (key: string, value: string)` The user labels applied to a resource must meet the following requirements: - Each resource can have multiple labels, up to a maximum of 64. - Each label must be a key-value pair. - Keys have a minimum length of 1 character and a maximum length of 63 characters and cannot be empty. Values can be empty and have a maximum length of 63 characters. - Keys and values can contain only lowercase letters, numeric characters, underscores, and dashes. All characters must use UTF-8 encoding, and international characters are allowed. - The key portion of a label must be unique. However, you can use the same key with multiple resources. - Keys must start with a lowercase letter or international character. See [Requirements for labels](https://cloud.google.com/resource-manager/docs/creating-managing-labels#requirements) for more details. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1alpha/RecommendResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/discoveryengine.readwrite`
- `https://www.googleapis.com/auth/discoveryengine.serving.readwrite`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `servingConfig` resource:

- `discoveryengine.servingConfigs.recommend`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).